Imports System.Runtime.InteropServices
Imports System.Text


Public Class WSQImageLibraryNativeMethods32
    'Friend NotInheritable Class WSQImageLibraryNativeMethods 'static class in vb.net, Friend = public, NotInheritable = static

    'Dim wsq_decompressed_byte_array_ptr As IntPtr = IntPtr.Zero
	'Dim out_comment_text_ptr As IntPtr = IntPtr.Zero
    'Dim wsq_compressed_byte_array_ptr As IntPtr = IntPtr.Zero
    'Dim bitmap_ptr As IntPtr = IntPtr.Zero
    Dim serial_number_ptr As IntPtr = IntPtr.Zero

    Private utf8 As New UTF8Encoding


    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
	Private Shared Function _GenerateWSQLibrarySerialNumber() As IntPtr
    End Function
    Public Function pGenerateWSQLibrarySerialNumber() As IntPtr

        Try
            serial_number_ptr = _GenerateWSQLibrarySerialNumber()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "GenerateWSQLibrarySerialNumber Exception")
        End Try
        pGenerateWSQLibrarySerialNumber = serial_number_ptr
    End Function



    <DllImport("WSQ_library.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
 Private Shared Function _UnlockWSQLibrary(ByVal unlock_code As Byte()) As Int32
    End Function
    Public Function pUnlockWSQLibrary(ByVal unlock_code_string As String) As Int32

        Dim retVal As Int32 = -1

        If (unlock_code_string = Nothing) Then
            Throw (New ArgumentNullException("unlock_code_string should be not null"))
        ElseIf (unlock_code_string.Length = 0) Then
            Throw New ArgumentException("Error: output_decompressed_byte_array_length of unlock_code_string is 0")
        End If
        Try
            retVal = _UnlockWSQLibrary(utf8.GetBytes(unlock_code_string))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "UnlockWSQLibrary Exception")
        End Try
        pUnlockWSQLibrary = retVal
    End Function


    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Sub _RegisterWSQ()
    End Sub
    Public Sub pRegisterWSQ()
        Try

            _RegisterWSQ()

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "RegisterWSQ Exception")
        End Try
    End Sub


    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _CreateBMPFromFile(ByVal lpszFileName As Byte()) As IntPtr
    End Function
    Public Function pCreateBMPFromFile(ByVal FileName As String) As IntPtr

        Static bitmap_ptr As IntPtr = IntPtr.Zero

        If (FileName = Nothing) Then
            Throw (New ArgumentNullException("FileName should be not null"))
        ElseIf (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try

            bitmap_ptr = _CreateBMPFromFile(utf8.GetBytes(FileName))

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "CreateBMPFromFile Exception")
        End Try

        pCreateBMPFromFile = bitmap_ptr

    End Function


    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _SaveBMPToFile(ByVal hBitmap As IntPtr, _
            ByVal filename As Byte(), <MarshalAs(UnmanagedType.I4)> ByVal filetype As Integer) As Integer
    End Function

    Public Function pSaveBMPToFile(ByVal Bitmap As IntPtr, ByVal FileName As String, ByVal FileType As Integer) As Integer

        Dim retVal As Integer = -1
        If (IsNothing(Bitmap)) Then
            Throw New ArgumentNullException("Bitmap should be not null")
        End If
        If (FileName = Nothing) Then
            Throw New ArgumentNullException("FileName should be not null")
        End If
        If (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try

            retVal = _SaveBMPToFile(Bitmap, utf8.GetBytes(FileName), FileType)

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "SaveBMPToFile Exception")
        End Try

        pSaveBMPToFile = retVal

    End Function



    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _CreateBMPFromWSQByteArray( _
        <[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal input_wsq_compressed_byte_array_length As Integer) As IntPtr
    End Function

    Public Function pCreateBMPFromWSQByteArray(<[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
              <[In]()> ByVal input_wsq_compressed_byte_array_length As Integer) As IntPtr

        Static bitmap_ptr As IntPtr = IntPtr.Zero

        Try

            bitmap_ptr = _CreateBMPFromWSQByteArray(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length)

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "CreateBMPFromWSQByteArray Exception")
        End Try

        pCreateBMPFromWSQByteArray = bitmap_ptr

    End Function


    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _SaveWSQByteArrayToImageFile( _
        <[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal input_wsq_compressed_byte_array_length As Integer, _
        ByVal lpszFileName As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal filetype As Integer) As Integer
    End Function

    Public Function pSaveWSQByteArrayToImageFile(<[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
              <[In]()> ByVal input_wsq_compressed_byte_array_length As Integer, ByVal FileName As String, ByVal FileType As Integer) As Integer

        Dim retVal As Integer = -1

        Try

            retVal = _SaveWSQByteArrayToImageFile(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, _
                    utf8.GetBytes(FileName), FileType)

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "SaveWSQByteArrayToImageFile Exception")
        End Try

        pSaveWSQByteArrayToImageFile = retVal

    End Function


    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Sub _SetShowFilePropertiesDialog( _
            <MarshalAs(UnmanagedType.I4)> ByVal file_properties_dialog As Integer)
    End Sub
    Public Sub pSetShowFilePropertiesDialog(ByVal file_properties_dialog As Integer)
        Try

            _SetShowFilePropertiesDialog(file_properties_dialog)

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "SetShowFilePropertiesDialog Exception")
        End Try
    End Sub




    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _WSQ_decode_stream( _
        <[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal input_wsq_compressed_byte_array_length As Integer, _
        ByRef output_decompressed_byte_array As IntPtr, _
        <MarshalAs(UnmanagedType.I4)> ByRef width As Integer, _
        <MarshalAs(UnmanagedType.I4)> ByRef height As Integer, _
        <MarshalAs(UnmanagedType.I4)> ByRef ppi As Integer, _
        ByRef comment_text As IntPtr) As Integer
    End Function


    Public Function pWSQ_decode_stream(<[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
                <[In]()> ByVal input_wsq_compressed_byte_array_length As Int32, _
                ByRef output_decompressed_byte_array As Byte(), _
                ByRef width As Int32, _
                ByRef height As Int32, _
                ByRef ppi As Int32, _
                ByRef comment_text As String) As Integer

        Dim retVal As Integer = -1

        Static wsq_decompressed_byte_array_ptr As IntPtr = IntPtr.Zero
        Static out_comment_text_ptr As IntPtr = IntPtr.Zero

        'If wsq_decompressed_byte_array_ptr = IntPtr.Zero Then
        'MsgBox("wsq_decompressed_byte_array_ptr = IntPtr.Zero", MsgBoxStyle.OkOnly, "WSQ Library Wrapper")
        'End If


        'output_decompressed_byte_array = Nothing
        output_decompressed_byte_array = New Byte() {}

        width = height = ppi = 0
        comment_text = String.Empty

        Try

            retVal = _WSQ_decode_stream(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, _
                    wsq_decompressed_byte_array_ptr, width, height, _
                    ppi, out_comment_text_ptr)


            comment_text = Marshal.PtrToStringAnsi(out_comment_text_ptr)
            Dim length As Integer = width * height
            'Erase output_decompressed_byte_array ' Free memory used by array
            ReDim output_decompressed_byte_array(length)
            Marshal.Copy(wsq_decompressed_byte_array_ptr, output_decompressed_byte_array, 0, length)


        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "WSQ_decode_stream Exception")
        End Try


        pWSQ_decode_stream = retVal

    End Function



    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _WSQ_encode_stream( _
        <[In]()> ByVal inputBuffer As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal width As Integer, _
        <MarshalAs(UnmanagedType.I4)> ByVal height As Integer, _
        <MarshalAs(UnmanagedType.R8)> ByVal bitrate As Double, _
        <MarshalAs(UnmanagedType.I4)> ByVal ppi As Integer, _
        <[In]()> ByVal comment_text As Byte(), _
        ByRef output_compressed_byte_array As IntPtr, _
        <MarshalAs(UnmanagedType.I4)> ByRef output_compressed_byte_array_length As Integer) As Integer
    End Function

    Public Function pWSQ_encode_stream( _
        ByVal inputBuffer As Byte(), _
        ByVal width As Integer, _
        ByVal height As Integer, _
        ByVal bitrate As Double, _
        ByVal ppi As Integer, _
        ByVal commentText As String, _
        ByRef output_compressed_byte_array As Byte(), _
        ByRef output_compressed_byte_array_length As Integer) As Integer

        Dim retVal As Integer = -1

        Static wsq_compressed_byte_array_ptr As IntPtr = IntPtr.Zero

        'output_compressed_byte_array = Nothing
        output_compressed_byte_array = New Byte() {}

        output_compressed_byte_array_length = 0

        Try

            retVal = _WSQ_encode_stream(inputBuffer, width, height, _
                    bitrate, ppi, utf8.GetBytes(commentText), _
                    wsq_compressed_byte_array_ptr, output_compressed_byte_array_length)


            If (output_compressed_byte_array_length = 0) Then
                Throw New ArgumentException("output_compressed_byte_array_length == 0")
            End If

            ReDim output_compressed_byte_array(output_compressed_byte_array_length)
            Marshal.Copy(wsq_compressed_byte_array_ptr, output_compressed_byte_array, 0, output_compressed_byte_array_length)


        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "WSQ_encode_stream Exception")
        End Try

        pWSQ_encode_stream = retVal

    End Function



    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function
    Public Function pConvertHBITMAPtoGrayScale256(ByVal Bitmap As IntPtr) As IntPtr

        Static bitmap_ptr As IntPtr = IntPtr.Zero

        Try

            bitmap_ptr = _ConvertHBITMAPtoGrayScale256(Bitmap)

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "ConvertHBITMAPtoGrayScale256 Exception")
        End Try

        pConvertHBITMAPtoGrayScale256 = bitmap_ptr

    End Function



    <DllImport("WSQ_library.dll", CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Cdecl)> _
    Private Shared Function _SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, _
            ByVal filename As Byte()) As Integer
    End Function
    Public Function pSaveHBITMAPtoFileAsGrayScale256BMP(ByVal Bitmap As IntPtr, ByVal FileName As String) As Integer

        Dim retVal As Integer = -1

        If (IsNothing(Bitmap)) Then
            Throw New ArgumentNullException("Bitmap should be not null")
        End If
        If (FileName = Nothing) Then
            Throw New ArgumentNullException("FileName should be not null")
        End If
        If (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try

            retVal = _SaveHBITMAPtoFileAsGrayScale256BMP(Bitmap, utf8.GetBytes(FileName))

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OKOnly, "SaveHBITMAPtoFileAsGrayScale256BMP Exception")
        End Try

        pSaveHBITMAPtoFileAsGrayScale256BMP = retVal

    End Function



End Class
